#ifndef __Bar_hpp__
#define __Bar_hpp__

#include <rtt/Logger.hpp>


namespace Test
{

  struct Bar
  {
 
  public :
    
    Bar()
    {
      RTT::Logger::In in(__PRETTY_FUNCTION__);
      RTT::Logger::log( RTT::Logger::Debug ) << "enter" << RTT::Logger::endl;
      m_flag = false;
      RTT::Logger::log( RTT::Logger::Debug ) << "exit" << RTT::Logger::endl;
    }

    Bar(const Bar &bar)
    {
      RTT::Logger::In in(__PRETTY_FUNCTION__);
      RTT::Logger::log( RTT::Logger::Debug ) << "enter" << RTT::Logger::endl;
      m_flag = bar.m_flag;
      RTT::Logger::log( RTT::Logger::Debug ) << "exit" << RTT::Logger::endl;
    }

    ~Bar()
    {
      RTT::Logger::In in(__PRETTY_FUNCTION__);
      RTT::Logger::log( RTT::Logger::Debug ) << "enter" << RTT::Logger::endl;
      RTT::Logger::log( RTT::Logger::Debug ) << "exit" << RTT::Logger::endl;
    }

    const Bar & operator=(const Bar &bar)
    {
      RTT::Logger::In in(__PRETTY_FUNCTION__);
      RTT::Logger::log( RTT::Logger::Debug ) << "enter" << RTT::Logger::endl;
      if(this != &bar)
        {
          if(m_flag != bar.m_flag)
            {
              RTT::Logger::log( RTT::Logger::Debug ) << "m_flag != bar.m_flag" << RTT::Logger::endl;
              m_flag = bar.m_flag;
            }
        }
      RTT::Logger::log( RTT::Logger::Debug ) << "exit" << RTT::Logger::endl;
      return *this;
    }

    bool m_flag;

  };

  std::ostream& operator<<(std::ostream& os, const Bar& bar);

  std::istream& operator>>(std::istream& is, Bar& bar);

}

#endif /* __Bar_hpp__ */
